"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.make = exports.create = void 0;
const typescript_1 = __importDefault(require("typescript"));
const syntaxKinds = {
    keyof: typescript_1.default.SyntaxKind.KeyOfKeyword,
    unique: typescript_1.default.SyntaxKind.UniqueKeyword,
    readonly: typescript_1.default.SyntaxKind.ReadonlyKeyword,
};
const create = ({ factory }) => (params) => {
    const node = factory.createTypeOperatorNode(syntaxKinds[params.syntaxKind], params.type);
    return node;
};
exports.create = create;
const make = (context) => {
    return {
        create: exports.create(context),
    };
};
exports.make = make;
//# sourceMappingURL=TypeOperatorNode.js.map