"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNamespace = void 0;
const Exception_1 = require("../../../Exception");
const Guard = __importStar(require("../Guard"));
const Name = __importStar(require("../Name"));
const PathItem = __importStar(require("./PathItem"));
const Reference = __importStar(require("./Reference"));
// 使わない可能性あり
const generateNamespace = (entryPoint, currentPoint, store, factory, pathItems, context, converterContext) => {
    const basePath = "components/pathItems";
    store.addComponent("pathItems", {
        kind: "namespace",
        name: Name.Components.PathItems,
    });
    Object.entries(pathItems).forEach(([key, pathItem]) => {
        if (Guard.isReference(pathItem)) {
            const reference = Reference.generate(entryPoint, currentPoint, pathItem);
            if (reference.type === "local") {
                throw new Exception_1.UnSupportError("can't use components.pathItems local reference");
            }
            else if (reference.componentName) {
                if (key !== reference.name) {
                    throw new Exception_1.UnSupportError(`can't use difference pathItem key name. "${key}" !== "${reference.name}"`);
                }
                PathItem.generateNamespace(entryPoint, reference.referencePoint, store, factory, basePath, reference.name, reference.data, context, converterContext);
            }
            else {
                throw new Exception_1.FeatureDevelopmentError("存在しないReferenceを参照する場合は全部生成する");
            }
        }
        else {
            PathItem.generateNamespace(entryPoint, currentPoint, store, factory, basePath, key, pathItem, context, converterContext);
        }
    });
};
exports.generateNamespace = generateNamespace;
//# sourceMappingURL=PathItems.js.map