"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateReferenceNamespace = exports.generateNamespace = void 0;
const path = __importStar(require("path"));
const Name = __importStar(require("../Name"));
const Header = __importStar(require("./Header"));
const MediaType = __importStar(require("./MediaType"));
const generateNamespace = (entryPoint, currentPoint, store, factory, parentPath, name, response, context, converterContext) => {
    const basePath = `${parentPath}/${name}`;
    store.addStatement(basePath, {
        kind: "namespace",
        name,
        comment: response.description,
    });
    if (response.headers) {
        store.addStatement(`${basePath}/Header`, {
            kind: "interface",
            name: Name.ComponentChild.Header,
            value: Header.generateInterface(entryPoint, currentPoint, factory, Name.ComponentChild.Header, response.headers, context, converterContext),
        });
    }
    if (response.content) {
        store.addStatement(`${basePath}/Content`, {
            kind: "interface",
            name: Name.ComponentChild.Content,
            value: MediaType.generateInterface(entryPoint, currentPoint, factory, Name.ComponentChild.Content, response.content, context, converterContext),
        });
    }
};
exports.generateNamespace = generateNamespace;
const generateReferenceNamespace = (entryPoint, currentPoint, store, factory, parentPath, nameWithStatusCode, responseReference, context, converterContext) => {
    const basePath = `${parentPath}/${nameWithStatusCode}`;
    const referenceNamespaceName = context.resolveReferencePath(currentPoint, responseReference.path).name;
    store.addStatement(basePath, {
        kind: "namespace",
        name: nameWithStatusCode,
    });
    const headerNamespace = store.getStatement(path.posix.join(responseReference.path, "Header"), "namespace");
    if (headerNamespace) {
        store.addStatement(`${basePath}/Header`, {
            kind: "namespace",
            name: Name.ComponentChild.Header,
        });
        Object.values(headerNamespace.getChildren()).forEach(statement => {
            if (!statement) {
                return;
            }
            if (statement.kind === "interface" || statement.kind === "typeAlias") {
                const aliasName = [referenceNamespaceName, Name.ComponentChild.Header, statement.name].join(".");
                store.addStatement(`${basePath}/Header/${statement.name}`, {
                    kind: "typeAlias",
                    name: aliasName,
                    value: factory.TypeAliasDeclaration.create({
                        export: true,
                        name: converterContext.escapeDeclarationText(statement.name),
                        type: factory.TypeReferenceNode.create({
                            name: aliasName,
                        }),
                    }),
                });
            }
        });
    }
    store.addStatement(`${basePath}/Content`, {
        kind: "typeAlias",
        name: Name.ComponentChild.Content,
        value: factory.TypeAliasDeclaration.create({
            export: true,
            name: Name.ComponentChild.Content,
            type: factory.TypeReferenceNode.create({
                name: referenceNamespaceName + "." + Name.ComponentChild.Content,
            }),
        }),
    });
};
exports.generateReferenceNamespace = generateReferenceNamespace;
//# sourceMappingURL=Response.js.map