"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.Name = exports.CodeGenerator = exports.OpenApi = void 0;
const TypeScriptCodeGenerator = __importStar(require("../../CodeGenerator"));
const CodeGenerator = __importStar(require("./CodeGenerator"));
exports.CodeGenerator = CodeGenerator;
const Comment = __importStar(require("./Comment"));
const Headers = __importStar(require("./components/Headers"));
const Parameters = __importStar(require("./components/Parameters"));
// import * as PathItems from "./components/PathItems";
const RequestBodies = __importStar(require("./components/RequestBodies"));
const Responses = __importStar(require("./components/Responses"));
const Schemas = __importStar(require("./components/Schemas"));
const ConvertContext = __importStar(require("./ConverterContext"));
const Name = __importStar(require("./Name"));
exports.Name = Name;
const Paths = __importStar(require("./paths"));
const store_1 = require("./store");
const TypeNodeContext = __importStar(require("./TypeNodeContext"));
const types_1 = require("./types");
Object.defineProperty(exports, "OpenApi", { enumerable: true, get: function () { return types_1.OpenApi; } });
const create = (entryPoint, rootSchema, noReferenceOpenApiSchema, option) => {
    const currentPoint = entryPoint;
    const converterContext = ConvertContext.create();
    const createFunction = (context) => {
        const factory = TypeScriptCodeGenerator.Factory.create(context);
        const store = store_1.Store.create(factory, noReferenceOpenApiSchema);
        const toTypeNodeContext = TypeNodeContext.create(entryPoint, store, factory, converterContext);
        if (rootSchema.components) {
            if (rootSchema.components.schemas) {
                Schemas.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.schemas, toTypeNodeContext, converterContext);
            }
            if (rootSchema.components.headers) {
                Headers.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.headers, toTypeNodeContext, converterContext);
            }
            if (rootSchema.components.responses) {
                Responses.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.responses, toTypeNodeContext, converterContext);
            }
            if (rootSchema.components.parameters) {
                Parameters.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.parameters, toTypeNodeContext, converterContext);
            }
            if (rootSchema.components.requestBodies) {
                RequestBodies.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.requestBodies, toTypeNodeContext, converterContext);
            }
            // if (rootSchema.components.securitySchemes) {
            //   SecuritySchemas.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.securitySchemes);
            // }
            // if (rootSchema.components.pathItems) {
            //   PathItems.generateNamespace(entryPoint, currentPoint, store, factory, rootSchema.components.pathItems, toTypeNodeContext);
            // }
            // TODO Feature Development
            // if (rootSchema.components.links) {
            //   statements.push(Links.generateNamespace(entryPoint, currentPoint, factory, rootSchema.components.links));
            // }
            // TODO Feature Development
            // if (rootSchema.components.callbacks) {
            //   statements.push(Callbacks.generateNamespace(entryPoint, currentPoint, factory, rootSchema.components.callbacks));
            // }
        }
        if (rootSchema.paths) {
            Paths.generateStatements(entryPoint, currentPoint, store, factory, rootSchema.paths, toTypeNodeContext, converterContext);
            CodeGenerator.generateApiClientCode(store, context, converterContext, option.rewriteCodeAfterTypeDeclaration, option.allowOperationIds, option.codeGeneratorOption);
        }
        return store.getRootStatements();
    };
    return {
        createFunction,
        generateLeadingComment: () => Comment.generateLeading(rootSchema),
        codeGeneratorOption: option.codeGeneratorOption,
    };
};
exports.create = create;
//# sourceMappingURL=index.js.map