"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.MethodBody = void 0;
const MethodBody = __importStar(require("./MethodBody"));
exports.MethodBody = MethodBody;
const generateParams = (factory, params) => {
    const typeArguments = [];
    if (params.has2OrMoreRequestContentTypes) {
        typeArguments.push(factory.TypeReferenceNode.create({
            name: "RequestContentType",
        }));
    }
    if (params.has2OrMoreSuccessResponseContentTypes) {
        typeArguments.push(factory.TypeReferenceNode.create({
            name: "ResponseContentType",
        }));
    }
    return factory.ParameterDeclaration.create({
        name: "params",
        modifiers: undefined,
        type: factory.TypeReferenceNode.create({
            name: params.argumentParamsTypeDeclaration,
            typeArguments,
        }),
    });
};
const generateResponseReturnType = (factory, successResponseNameList, successResponseContentTypeList, option) => {
    let objectType = factory.TypeNode.create({
        type: "void",
    });
    if (successResponseNameList.length === 1) {
        objectType = factory.TypeReferenceNode.create({
            name: successResponseNameList[0],
        });
    }
    else if (successResponseNameList.length > 1) {
        objectType = factory.UnionTypeNode.create({
            typeNodes: successResponseNameList.map(item => factory.TypeReferenceNode.create({ name: item })),
        });
    }
    // レスポンスが存在しないので Promise<void>
    if (successResponseNameList.length === 0) {
        if (option.sync) {
            return objectType;
        }
        return factory.TypeReferenceNode.create({
            name: "Promise",
            typeArguments: [objectType],
        });
    }
    const isOnlyOneResponseContentType = successResponseContentTypeList.length === 1;
    let indexType = factory.TypeReferenceNode.create({
        name: "ResponseContentType",
    });
    if (isOnlyOneResponseContentType) {
        indexType = factory.TypeReferenceNode.create({
            name: `"${successResponseContentTypeList[0]}"`,
        });
    }
    if (option.sync) {
        return factory.IndexedAccessTypeNode.create({
            objectType,
            indexType,
        });
    }
    return factory.TypeReferenceNode.create({
        name: "Promise",
        typeArguments: [
            factory.IndexedAccessTypeNode.create({
                objectType,
                indexType,
            }),
        ],
    });
};
const methodTypeParameters = (factory, params) => {
    const typeParameters = [];
    if (params.has2OrMoreRequestContentTypes) {
        typeParameters.push(factory.TypeParameterDeclaration.create({
            name: "RequestContentType",
            constraint: factory.TypeReferenceNode.create({
                name: params.requestContentTypeName,
            }),
        }));
    }
    if (params.has2OrMoreSuccessResponseContentTypes) {
        typeParameters.push(factory.TypeParameterDeclaration.create({
            name: "ResponseContentType",
            constraint: factory.TypeReferenceNode.create({
                name: params.responseContentTypeName,
            }),
        }));
    }
    return typeParameters;
};
/**
 *
 * public async {functionName}(params: {argumentParamsTypeDeclaration}<{RequestContentType}>): Promise<{requestBodyName}[ResponseContentType]> {
 *
 * }
 */
const create = (factory, params, option) => {
    const typeParameters = methodTypeParameters(factory, params);
    const methodArguments = [];
    const hasParamsArguments = params.hasParameter || params.hasRequestBody || params.has2OrMoreSuccessResponseContentTypes || params.has2OrMoreRequestContentTypes;
    if (hasParamsArguments) {
        methodArguments.push(generateParams(factory, params));
    }
    const returnType = generateResponseReturnType(factory, params.responseSuccessNames, params.successResponseContentTypes, option);
    methodArguments.push(factory.ParameterDeclaration.create({
        name: "option",
        modifiers: undefined,
        optional: true,
        type: factory.TypeReferenceNode.create({
            name: "RequestOption",
        }),
    }));
    return factory.MethodDeclaration.create({
        name: params.functionName,
        async: !option.sync,
        parameters: methodArguments,
        comment: params.comment,
        deprecated: params.deprecated,
        type: returnType,
        typeParameters: typeParameters,
        body: factory.Block.create({
            statements: MethodBody.create(factory, params),
            multiLine: true,
        }),
    });
};
exports.create = create;
//# sourceMappingURL=Method.js.map