"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rewriteCodeAfterTypeDeclaration = void 0;
const TypeScriptCodeGenerator = __importStar(require("../CodeGenerator"));
const ApiClientArgument = __importStar(require("./ApiClientArgument"));
const ApiClientClass = __importStar(require("./ApiClientClass"));
const rewriteCodeAfterTypeDeclaration = (context, codeGeneratorParamsList, option) => {
    const statements = [];
    const factory = TypeScriptCodeGenerator.Factory.create(context);
    codeGeneratorParamsList.forEach(codeGeneratorParams => {
        if (codeGeneratorParams.hasRequestBody) {
            statements.push(ApiClientArgument.createRequestContentTypeReference(factory, codeGeneratorParams));
        }
        if (codeGeneratorParams.responseSuccessNames.length > 0) {
            statements.push(ApiClientArgument.createResponseContentTypeReference(factory, codeGeneratorParams));
        }
        const typeDeclaration = ApiClientArgument.create(factory, codeGeneratorParams);
        if (typeDeclaration) {
            statements.push(typeDeclaration);
        }
    });
    ApiClientClass.create(factory, codeGeneratorParamsList, option).forEach(newStatement => {
        statements.push(newStatement);
    });
    return statements;
};
exports.rewriteCodeAfterTypeDeclaration = rewriteCodeAfterTypeDeclaration;
//# sourceMappingURL=index.js.map