"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateTypeScriptCode = exports.Converter = void 0;
const os_1 = require("os");
const TypeScriptCodeGenerator = __importStar(require("./CodeGenerator"));
const Converter = __importStar(require("./Converter"));
exports.Converter = Converter;
const DefaultCodeTemplate = __importStar(require("./DefaultCodeTemplate"));
const FileSystem_1 = require("./FileSystem");
const ResolveReference = __importStar(require("./ResolveReference"));
const Validator = __importStar(require("./Validator"));
const generateConvertOption = (filter = {}, option) => {
    if (option) {
        return {
            rewriteCodeAfterTypeDeclaration: option.rewriteCodeAfterTypeDeclaration || DefaultCodeTemplate.rewriteCodeAfterTypeDeclaration,
            allowOperationIds: filter.allowOperationIds,
            codeGeneratorOption: {
                sync: option.codeGenerator ? !!option.codeGenerator.sync : false,
            },
        };
    }
    return {
        rewriteCodeAfterTypeDeclaration: DefaultCodeTemplate.rewriteCodeAfterTypeDeclaration,
        allowOperationIds: filter.allowOperationIds,
        codeGeneratorOption: {
            sync: false,
        },
    };
};
const generateTypeScriptCode = ({ entryPoint, option, enableValidate = true, log, filter = {} }) => {
    const schema = FileSystem_1.fileSystem.loadJsonOrYaml(entryPoint);
    const resolvedReferenceDocument = ResolveReference.resolve(entryPoint, entryPoint, JSON.parse(JSON.stringify(schema)));
    if (enableValidate) {
        Validator.v3.validate(resolvedReferenceDocument, log && log.validator);
    }
    const convertOption = generateConvertOption(filter, option);
    const { createFunction, generateLeadingComment } = Converter.v3.create(entryPoint, schema, resolvedReferenceDocument, convertOption);
    return [generateLeadingComment(), TypeScriptCodeGenerator.generate(createFunction)].join(os_1.EOL + os_1.EOL + os_1.EOL);
};
exports.generateTypeScriptCode = generateTypeScriptCode;
//# sourceMappingURL=index.js.map