import ts from "typescript";
export const create = ({ factory }) => (params) => {
    const modifiers = (() => {
        if (params.modifiers === "private") {
            return [factory.createModifier(ts.SyntaxKind.PrivateKeyword)];
        }
        if (params.modifiers === "public") {
            return [factory.createModifier(ts.SyntaxKind.PublicKeyword)];
        }
        return;
    })();
    const node = factory.createParameterDeclaration(undefined, modifiers, undefined, factory.createIdentifier(params.name), params.optional && factory.createToken(ts.SyntaxKind.QuestionToken), params.type, undefined);
    return node;
};
export const make = (context) => {
    return {
        create: create(context),
    };
};
//# sourceMappingURL=ParameterDeclaration.js.map