import * as TypeScriptCodeGenerator from "../CodeGenerator";
import * as ApiClientArgument from "./ApiClientArgument";
import * as ApiClientClass from "./ApiClientClass";
export const rewriteCodeAfterTypeDeclaration = (context, codeGeneratorParamsList, option) => {
    const statements = [];
    const factory = TypeScriptCodeGenerator.Factory.create(context);
    codeGeneratorParamsList.forEach(codeGeneratorParams => {
        if (codeGeneratorParams.hasRequestBody) {
            statements.push(ApiClientArgument.createRequestContentTypeReference(factory, codeGeneratorParams));
        }
        if (codeGeneratorParams.responseSuccessNames.length > 0) {
            statements.push(ApiClientArgument.createResponseContentTypeReference(factory, codeGeneratorParams));
        }
        const typeDeclaration = ApiClientArgument.create(factory, codeGeneratorParams);
        if (typeDeclaration) {
            statements.push(typeDeclaration);
        }
    });
    ApiClientClass.create(factory, codeGeneratorParamsList, option).forEach(newStatement => {
        statements.push(newStatement);
    });
    return statements;
};
//# sourceMappingURL=index.js.map