import * as TypeScriptCodeGenerator from "../../CodeGenerator";
import * as CodeGenerator from "./CodeGenerator";
import * as Name from "./Name";
import { CodeGeneratorParams, OpenApi, PickedParameter } from "./types";
export { OpenApi, CodeGenerator, CodeGeneratorParams, PickedParameter, Name };
export interface Type {
    generateLeadingComment: () => string;
    createFunction: TypeScriptCodeGenerator.CreateFunction;
    codeGeneratorOption: CodeGenerator.Option;
}
export interface Option {
    /**
     * It is possible to rewrite the implementation after the type declaration.
     */
    rewriteCodeAfterTypeDeclaration: CodeGenerator.RewriteCodeAfterTypeDeclaration;
    /**
     *
     */
    codeGeneratorOption: CodeGenerator.Option;
    /**
     * List of operationId to be used
     */
    allowOperationIds?: string[];
}
export declare const create: (entryPoint: string, rootSchema: OpenApi.Document, noReferenceOpenApiSchema: OpenApi.Document, option: Option) => Type;
